#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#define EPSILON (1.0E-3)

int main (int argc, char *argv[]) {
	int n = 512;
	if (argc > 1 && argc != 2) {
		printf("usage: ./LU input_order \n");
		exit(0);
	}

	if (argc == 2) {
                n = atoi(argv[1]);
	}

	double Mat[n][n], L[n][n], U[n][n];
	// initialization of arrays
	srand(time(NULL));
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++) {
			Mat[i][j] =  rand() % 11;
			U[i][j] = Mat[i][j];

			if (i == j)
				L[i][j] = 1;
			else
				L[i][j] = 0;
		}

        // computation of L and U assuming U[k][k]
        // is always invertible
	for (int k = 0; k < n; ++k) {
		for (int i = 0; i < n-k-1; i++) {
			int p = i + k + 1;
			L[k][p] = U[k][p] / U[k][k]; // column major representation of L and U
            		for (int j = k; j < n; j++)
                             U[j][p] -= L[k][p] * U[j][k]; // column major representation of L and U
        	}
	}


	return 0;
}
