#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#include <malloc.h>
#include <iostream>
#include <cilk/cilk.h>
#include <cilk/cilk_api.h>
#include <cilktools/cilkview.h>

/* waste time */
int fib(int n)
{
    if (n < 2) return n;
    return fib(n-1)+fib(n-2);
}

/* Code starts here: */
/*------------------------------------------------------------*/
const int N = 1000000;

void test_inner_parallel()
{
    for (int i = 0; i < N; ++i)
	cilk_for (int j = 0; j < 4; ++j)
	    fib(10); /* waste time */
}

void test_outer_parallel()
{
    cilk_for (int j = 0; j < 4; ++j)
	for (int i = 0; i < N; ++i)
	    fib(10); /* waste time */
}
/*------------------------------------------------------------*/
/* Code ends here */


/* test driver: */

int main(int argc, char *argv[])
{
  {
    cilkview_data_t d;
    __cilkview_query(d);    
    test_inner_parallel();
     __cilkview_report(&d, NULL, "test_inner_parallel", CV_REPORT_WRITE_TO_RESULTS);
  }
  
  {
    cilkview_data_t d;
    __cilkview_query(d); 
    test_outer_parallel();
    __cilkview_report(&d, NULL, "test_outer_parallel", CV_REPORT_WRITE_TO_RESULTS);
  }
 
  return 0;
}
