#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <cilk/cilk.h>
#include <cilk/cilk_api.h>
#include <cilktools/cilkview.h>

/* waste time */
int fib(int n)
{
    if (n < 2) return n;
    return fib(n-1)+fib(n-2);
}

/* Code starts here: */
/*------------------------------------------------------------*/
const int N = 100000000;

void test_cilk_for_grainsize_1()
{
#pragma cilk_grainsize = 1
    cilk_for(int i = 0; i < N; ++i)
	fib(10);
}

void test_cilk_for_default_grainsize()
{
    cilk_for(int i = 0; i < N; ++i)
	fib(10);
}

void test_cilk_for_large_grainsize()
{
#pragma cilk_grainsize = N
    cilk_for(int i = 0; i < N; ++i)
	fib(10);
}
/*------------------------------------------------------------*/
/* Code ends here */

/* test driver: */

int main(int argc, char *argv[])
{
  {
    cilkview_data_t d;
    __cilkview_query(d);
    
    test_cilk_for_grainsize_1();

    __cilkview_report(&d, NULL, "test_cilk_for_grainsize_1", CV_REPORT_WRITE_TO_RESULTS);
  }
  
  {
    cilkview_data_t d;
    __cilkview_query(d);

    test_cilk_for_default_grainsize();
  
    __cilkview_report(&d, NULL, "test_cilk_for_default_grainsize", CV_REPORT_WRITE_TO_RESULTS);
  }
    
  {
    cilkview_data_t d;
    __cilkview_query(d);

    test_cilk_for_large_grainsize();

    __cilkview_report(&d, NULL, "test_cilk_for_large_grainsize", CV_REPORT_WRITE_TO_RESULTS);
  }

  return 0;
}
