#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <cilk/cilk.h>
#include <cilk/cilk_api.h>
#include <cilktools/cilkview.h>

/* waste time */
int fib(int n)
{
    if (n < 2) return n;
    return fib(n-1)+fib(n-2);
}

/* Code starts here: */
/*------------------------------------------------------------*/
const int N = 100000000;

void test_cilk_for_grainsize_1()
{
#pragma cilk_grainsize = 1
    cilk_for(int i = 0; i < N; ++i)
	fib(2);
}

void test_cilk_for_default_grainsize()
{
    cilk_for(int i = 0; i < N; ++i)
	fib(2);
}

void test_cilk_for_large_grainsize()
{
#pragma cilk_grainsize = N
    cilk_for(int i = 0; i < N; ++i)
	fib(2);
}
/*------------------------------------------------------------*/
/* Code ends here */

/* test driver: */

int main(int argc, char *argv[])
{
  std::cout<<"#workers: "<<__cilkrts_get_nworkers()<<std::endl;

  {
    unsigned long long start = __cilkview_getticks();
    test_cilk_for_grainsize_1();
    unsigned long long end = __cilkview_getticks();
    float elapsed = (end - start);    
    std::cout << "test_cilk_for_grainsize_1 takes: " << elapsed << " (ms)" << std::endl;
  }
  
  {
    unsigned long long start = __cilkview_getticks();

    test_cilk_for_default_grainsize();
    unsigned long long end = __cilkview_getticks();
    float elapsed = (end - start);
    std::cout << "test_cilk_for_default_grainsize takes: " << elapsed << " (ms)" << std::endl;
  }
    
  {
    unsigned long long start = __cilkview_getticks();

    test_cilk_for_large_grainsize();

    unsigned long long end = __cilkview_getticks();
    float elapsed = (end - start);
    std::cout << "test_cilk_for_large_grainsize takes: " << elapsed << " (ms)" << std::endl;
  }

  return 0;
}
