#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <cilk/cilk.h>
#include <cilk/cilk_api.h>
#include <cilktools/cilkview.h>

/* Code starts here: */
/*------------------------------------------------------------*/
const int N = 10000000;

/* empty test function */
void f() { }

void test_for_spawn()
{
    for(int i = 0; i < N; ++i)
	cilk_spawn f();
}

void test_cilk_for()
{
    cilk_for(int i = 0; i < N; ++i)
	f();
}

void test_cilk_for_with_grainsize()
{
#pragma cilk_grainsize = 1
    cilk_for(int i = 0; i < N; ++i)
	f();
}
/*------------------------------------------------------------*/
/* Code ends here */

/* test driver: */

int main(int argc, char *argv[])
{
  {
    cilkview_data_t d;
    __cilkview_query(d);
    
    test_for_spawn();

    __cilkview_report(&d, NULL, "test_for_spawn", CV_REPORT_WRITE_TO_RESULTS);
  }
  
  {
    cilkview_data_t d;
    __cilkview_query(d);

    test_cilk_for();
  
    __cilkview_report(&d, NULL, "test_cilk_for", CV_REPORT_WRITE_TO_RESULTS);
  }
    
  {
    cilkview_data_t d;
    __cilkview_query(d);

    test_cilk_for_with_grainsize();

    __cilkview_report(&d, NULL, "test_cilk_for_with_grainsize", CV_REPORT_WRITE_TO_RESULTS);
  }

  return 0;
}
