#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <cilk/cilk.h>
#include <cilk/cilk_api.h>
#include <cilktools/cilkview.h>

/* waste time */
int fib(int n)
{
    if (n < 2) return n;
    return fib(n-1)+fib(n-2);
}

/* Code starts here: */
/*------------------------------------------------------------*/
const int N = 50000000;

double A[N], B[N], C[N];

void test_mem_bw()
{
    cilk_for (int i = 0; i < N; ++i)
	A[i] = B[i] + C[i];
}

void test_mem_bw_extra_work()
{
    cilk_for (int i = 0; i < N; ++i) {
	A[i] = B[i] + C[i];
	fib(5);
    }
}

void test_mem_bw_more_extra_work()
{
    cilk_for (int i = 0; i < N; ++i) {
	A[i] = B[i] + C[i];
	fib(10);
    }
}
/*------------------------------------------------------------*/
/* Code ends here */

/* test driver: */

#include <string.h>
int main(int argc, char *argv[])
{
  memset(A, 0, sizeof(A));
  memset(B, 0, sizeof(B));
  memset(C, 0, sizeof(C));
  
  {
    cilkview_data_t d;
    __cilkview_query(d);

    test_mem_bw();	

    __cilkview_report(&d, NULL, "test_mem_bw", CV_REPORT_WRITE_TO_RESULTS);
  }

  {
    cilkview_data_t d;
    __cilkview_query(d);

    test_mem_bw_extra_work();

    __cilkview_report(&d, NULL, "test_mem_bw_extra_work", CV_REPORT_WRITE_TO_RESULTS);
  }
  
  {
    cilkview_data_t d;
    __cilkview_query(d);
    
    test_mem_bw_more_extra_work();

    __cilkview_report(&d, NULL, "test_mem_bw_more_extra_work", CV_REPORT_WRITE_TO_RESULTS);
  }

  return 0;
}
